//+------------------------------------------------------------------+
//|                                                  rotate_text.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
#property stacksize 65536
#property show_inputs

#include <stdlib.mqh>

#import "cyberia.dll"
void CyberiaInit();
void CyberiaDeInit();
void SaveTick (string, string, string, int, double, double, double);
int AskCyberia ( string, string, string );
#import

extern int PathLimit = 767;

double Counter;

string PathEURUSD,PathUSDCHF,PathGBPUSD,PathUSDJPY;
string PathAUDUSD,PathUSDCAD,PathEURCHF,PathEURJPY;
string PathEURGBP,PathGBPJPY,PathGBPCHF,PathEURCAD;
string PathEURAUD,PathNZDUSD,PathUSDSEK,PathUSDDKK;
string PathUSDNOK,PathUSDSGD,PathUSDZAR,PathCHFJPY;
string PathGOLD;

double BidPrevEURUSD,BidPrevUSDCHF,BidPrevGBPUSD,BidPrevUSDJPY;
double BidPrevAUDUSD,BidPrevUSDCAD,BidPrevEURCHF,BidPrevEURJPY;
double BidPrevEURGBP,BidPrevGBPJPY,BidPrevGBPCHF,BidPrevEURCAD;
double BidPrevEURAUD,BidPrevNZDUSD,BidPrevUSDSEK,BidPrevUSDDKK;
double BidPrevUSDNOK,BidPrevUSDSGD,BidPrevUSDZAR,BidPrevCHFJPY;
double BidPrevGOLD;

int DelthaEURUSD,DelthaUSDCHF,DelthaGBPUSD,DelthaUSDJPY;
int DelthaAUDUSD,DelthaUSDCAD,DelthaEURCHF,DelthaEURJPY;
int DelthaEURGBP,DelthaGBPJPY,DelthaGBPCHF,DelthaEURCAD;
int DelthaEURAUD,DelthaNZDUSD,DelthaUSDSEK,DelthaUSDDKK;
int DelthaUSDNOK,DelthaUSDSGD,DelthaUSDZAR,DelthaCHFJPY;
int DelthaGOLD;

void init()  {
   PathEURUSD = ""; PathUSDCHF = ""; PathGBPUSD = ""; PathUSDJPY = "";
   Counter = 0;
   BidPrevEURUSD = MarketInfo("EURUSD",MODE_BID);
   BidPrevUSDCHF = MarketInfo("USDCHF",MODE_BID);
   BidPrevGBPUSD = MarketInfo("GBPUSD",MODE_BID);
   BidPrevUSDJPY = MarketInfo("USDJPY",MODE_BID);
   
   BidPrevAUDUSD = MarketInfo("AUDUSD",MODE_BID);
   BidPrevUSDCAD = MarketInfo("USDCAD",MODE_BID);
   BidPrevEURCHF = MarketInfo("EURCHF",MODE_BID);
   BidPrevEURJPY = MarketInfo("EURJPY",MODE_BID);
   
   BidPrevEURGBP = MarketInfo("EURGBP",MODE_BID);
   BidPrevGBPJPY = MarketInfo("GBPJPY",MODE_BID);
   BidPrevGBPCHF = MarketInfo("GBPCHF",MODE_BID);
   BidPrevEURCAD = MarketInfo("EURCAD",MODE_BID);
   
   BidPrevEURAUD = MarketInfo("EURAUD",MODE_BID);
   BidPrevNZDUSD = MarketInfo("NZDUSD",MODE_BID);
   BidPrevUSDSEK = MarketInfo("USDSEK",MODE_BID);
   BidPrevUSDDKK = MarketInfo("USDDKK",MODE_BID);
   
   BidPrevUSDNOK = MarketInfo("USDNOK",MODE_BID);
   BidPrevUSDSGD = MarketInfo("USDSGD",MODE_BID);
   BidPrevUSDZAR = MarketInfo("USDZAR",MODE_BID);
   BidPrevCHFJPY = MarketInfo("CHFJPY",MODE_BID);
   BidPrevGOLD = MarketInfo("GOLD",MODE_BID);
//--
   CyberiaInit();
//--   
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit()
  {
//--
   CyberiaDeInit();     
   return(0);
//--  
  }

int SaveStatEURUSD(){
   DelthaEURUSD = MarketInfo("EURUSD",MODE_BID) * MathPow(10, MarketInfo("EURUSD",MODE_DIGITS)) - BidPrevEURUSD * MathPow(10, MarketInfo("EURUSD",MODE_DIGITS));
   if(DelthaEURUSD!=0)
   {
     PathEURUSD = StringConcatenate( DoubleToStr ( DelthaEURUSD, 0 ), PathEURUSD );
   if (DelthaEURUSD >= 0) {
      PathEURUSD = StringConcatenate("+", PathEURUSD);
      }         
   }

   PathEURUSD = StringSubstr ( PathEURUSD, 0, PathLimit );
   
   if (MarketInfo("EURUSD",MODE_BID)!= BidPrevEURUSD){
      Counter ++;
      SaveTick ( CompanyName(), "EURUSD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("EURUSD",MODE_BID), MarketInfo("EURUSD",MODE_ASK), MarketInfo("EURUSD",MODE_POINT));     //  (Australian Dollar vs Canadian Dollar)
      BidPrevEURUSD = MarketInfo("EURUSD",MODE_BID); //  (Australian Dollar vs Canadian Dollar)
      }
      
  int buy_sell=AskCyberia ( CompanyName(), "EURUSD", PathEURUSD );   
   Comment("");
   Comment("Buy/Sell: ",buy_sell,"\n",PathEURUSD);
         
   return (0);
}

int SaveStatUSDCHF(){
   DelthaUSDCHF = MarketInfo("USDCHF",MODE_BID) * MathPow(10, MarketInfo("USDCHF",MODE_DIGITS)) - BidPrevUSDCHF * MathPow(10, MarketInfo("USDCHF",MODE_DIGITS));
   PathUSDCHF = StringConcatenate( DoubleToStr ( DelthaUSDCHF, 0 ), PathUSDCHF );
   if (DelthaUSDCHF >= 0) {
      PathUSDCHF = StringConcatenate("+", PathUSDCHF);
      }
   PathUSDCHF = StringSubstr ( PathUSDCHF, 0, PathLimit );   
   if (MarketInfo("USDCHF",MODE_BID)!= BidPrevUSDCHF){
   Counter ++;
   SaveTick ( CompanyName(), "USDCHF", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDCHF",MODE_BID), MarketInfo("USDCHF",MODE_ASK), MarketInfo("USDCHF",MODE_POINT));     //  (Australian Dollar vs Swiss Franc)
   BidPrevUSDCHF = MarketInfo("USDCHF",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatGBPUSD(){
   DelthaGBPUSD = MarketInfo("GBPUSD",MODE_BID) * MathPow(10, MarketInfo("GBPUSD",MODE_DIGITS)) - BidPrevGBPUSD * MathPow(10, MarketInfo("GBPUSD",MODE_DIGITS));
   PathGBPUSD = StringConcatenate( DoubleToStr ( DelthaGBPUSD, 0 ), PathGBPUSD );
   if (DelthaGBPUSD >= 0) {
      PathGBPUSD = StringConcatenate("+", PathGBPUSD);
      }
   PathGBPUSD = StringSubstr ( PathGBPUSD, 0, PathLimit );      
   if (MarketInfo("GBPUSD",MODE_BID)!= BidPrevGBPUSD){
   Counter ++;
   SaveTick ( CompanyName(), "GBPUSD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("GBPUSD",MODE_BID), MarketInfo("GBPUSD",MODE_ASK), MarketInfo("GBPUSD",MODE_POINT));     //  (Australian Dollar vs Czech Republic Koruna)
   BidPrevGBPUSD = MarketInfo("GBPUSD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatUSDJPY(){
   DelthaUSDJPY = MarketInfo("USDJPY",MODE_BID) * MathPow(10, MarketInfo("USDJPY",MODE_DIGITS)) - BidPrevUSDJPY * MathPow(10, MarketInfo("USDJPY",MODE_DIGITS));
   PathUSDJPY = StringConcatenate( DoubleToStr ( DelthaUSDJPY, 0 ), PathUSDJPY );
   if (DelthaUSDJPY >= 0) {
      PathUSDJPY = StringConcatenate("+", PathUSDJPY);
      }
   PathUSDJPY = StringSubstr ( PathUSDJPY, 0, PathLimit );      
   if (MarketInfo("USDJPY",MODE_BID)!= BidPrevUSDJPY){
   Counter ++;   
   SaveTick ( CompanyName(), "USDJPY", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDJPY",MODE_BID), MarketInfo("USDJPY",MODE_ASK), MarketInfo("USDJPY",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevUSDJPY = MarketInfo("USDJPY",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatAUDUSD(){
   DelthaAUDUSD = MarketInfo("AUDUSD",MODE_BID) * MathPow(10, MarketInfo("AUDUSD",MODE_DIGITS)) - BidPrevAUDUSD * MathPow(10, MarketInfo("AUDUSD",MODE_DIGITS));
   PathAUDUSD = StringConcatenate( DoubleToStr ( DelthaAUDUSD, 0 ), PathAUDUSD );
   if (DelthaAUDUSD >= 0) {
      PathAUDUSD = StringConcatenate("+", PathAUDUSD);
      }
   PathAUDUSD = StringSubstr ( PathAUDUSD, 0, PathLimit );      
   if (MarketInfo("AUDUSD",MODE_BID)!= BidPrevAUDUSD){
   Counter ++;   
   SaveTick ( CompanyName(), "AUDUSD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("AUDUSD",MODE_BID), MarketInfo("AUDUSD",MODE_ASK), MarketInfo("AUDUSD",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevAUDUSD = MarketInfo("AUDUSD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatUSDCAD(){
   DelthaUSDCAD = MarketInfo("USDCAD",MODE_BID) * MathPow(10, MarketInfo("USDCAD",MODE_DIGITS)) - BidPrevUSDCAD * MathPow(10, MarketInfo("USDCAD",MODE_DIGITS));
   PathUSDCAD = StringConcatenate( DoubleToStr ( DelthaUSDCAD, 0 ), PathUSDCAD );
   if (DelthaUSDCAD >= 0) {
      PathUSDCAD = StringConcatenate("+", PathUSDCAD);
      }
   PathUSDCAD = StringSubstr ( PathUSDCAD, 0, PathLimit );      
   if (MarketInfo("USDCAD",MODE_BID)!= BidPrevUSDCAD){
   Counter ++;   
   SaveTick ( CompanyName(), "USDCAD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDCAD",MODE_BID), MarketInfo("USDCAD",MODE_ASK), MarketInfo("USDCAD",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevUSDCAD = MarketInfo("USDCAD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatEURCHF(){
   DelthaEURCHF = MarketInfo("EURCHF",MODE_BID) * MathPow(10, MarketInfo("EURCHF",MODE_DIGITS)) - BidPrevEURCHF * MathPow(10, MarketInfo("EURCHF",MODE_DIGITS));
   PathEURCHF = StringConcatenate( DoubleToStr ( DelthaEURCHF, 0 ), PathEURCHF );
   if (DelthaEURCHF >= 0) {
      PathEURCHF = StringConcatenate("+", PathEURCHF);
      }
   PathEURCHF = StringSubstr ( PathEURCHF, 0, PathLimit );      
   if (MarketInfo("EURCHF",MODE_BID)!= BidPrevEURCHF){
   Counter ++;   
   SaveTick ( CompanyName(), "EURCHF", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("EURCHF",MODE_BID), MarketInfo("EURCHF",MODE_ASK), MarketInfo("EURCHF",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevEURCHF = MarketInfo("EURCHF",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}   
   

int SaveStatEURJPY(){
   DelthaEURJPY = MarketInfo("EURJPY",MODE_BID) * MathPow(10, MarketInfo("EURJPY",MODE_DIGITS)) - BidPrevEURCHF * MathPow(10, MarketInfo("EURJPY",MODE_DIGITS));
   PathEURJPY = StringConcatenate( DoubleToStr ( DelthaEURJPY, 0 ), PathEURJPY );
   if (DelthaEURJPY >= 0) {
      PathEURJPY = StringConcatenate("+", PathEURJPY);
      }
   PathEURJPY = StringSubstr ( PathEURJPY, 0, PathLimit );      
   if (MarketInfo("EURJPY",MODE_BID)!= BidPrevEURJPY){
   Counter ++;   
   SaveTick ( CompanyName(), "EURJPY", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("EURJPY",MODE_BID), MarketInfo("EURJPY",MODE_ASK), MarketInfo("EURJPY",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevEURJPY = MarketInfo("EURJPY",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}
   
int SaveStatEURGBP(){
   DelthaEURGBP = MarketInfo("EURGBP",MODE_BID) * MathPow(10, MarketInfo("EURGBP",MODE_DIGITS)) - BidPrevEURGBP * MathPow(10, MarketInfo("EURGBP",MODE_DIGITS));
   PathEURGBP = StringConcatenate( DoubleToStr ( DelthaEURGBP, 0 ), PathEURGBP );
   if (DelthaEURGBP >= 0) {
      PathEURGBP = StringConcatenate("+", PathEURGBP);
      }
   PathEURGBP = StringSubstr ( PathEURGBP, 0, PathLimit );      
   if (MarketInfo("EURGBP",MODE_BID)!= BidPrevEURGBP){
   Counter ++;   
   SaveTick ( CompanyName(), "EURGBP", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("EURGBP",MODE_BID), MarketInfo("EURGBP",MODE_ASK), MarketInfo("EURGBP",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevEURGBP = MarketInfo("EURGBP",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatGBPJPY(){
   DelthaGBPJPY = MarketInfo("GBPJPY",MODE_BID) * MathPow(10, MarketInfo("GBPJPY",MODE_DIGITS)) - BidPrevGBPJPY * MathPow(10, MarketInfo("GBPJPY",MODE_DIGITS));
   PathGBPJPY = StringConcatenate( DoubleToStr ( DelthaGBPJPY, 0 ), PathGBPJPY );
   if (DelthaGBPJPY >= 0) {
      PathGBPJPY = StringConcatenate("+", PathGBPJPY);
      }
   PathGBPJPY = StringSubstr ( PathGBPJPY, 0, PathLimit );      
   if (MarketInfo("GBPJPY",MODE_BID)!= BidPrevGBPJPY){
   Counter ++;   
   SaveTick ( CompanyName(), "GBPJPY", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("GBPJPY",MODE_BID), MarketInfo("GBPJPY",MODE_ASK), MarketInfo("GBPJPY",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevGBPJPY = MarketInfo("GBPJPY",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatGBPCHF(){
   DelthaGBPCHF = MarketInfo("GBPCHF",MODE_BID) * MathPow(10, MarketInfo("GBPCHF",MODE_DIGITS)) - BidPrevGBPCHF * MathPow(10, MarketInfo("GBPCHF",MODE_DIGITS));
   PathGBPCHF = StringConcatenate( DoubleToStr ( DelthaGBPCHF, 0 ), PathGBPCHF );
   if (DelthaGBPCHF >= 0) {
      PathGBPCHF = StringConcatenate("+", PathGBPCHF);
      }
   PathGBPCHF = StringSubstr ( PathGBPCHF, 0, PathLimit );      
   if (MarketInfo("GBPCHF",MODE_BID)!= BidPrevGBPCHF){
   Counter ++;   
   SaveTick ( CompanyName(), "GBPCHF", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("GBPCHF",MODE_BID), MarketInfo("GBPCHF",MODE_ASK), MarketInfo("GBPCHF",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevGBPCHF = MarketInfo("GBPCHF",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}
   
int SaveStatEURCAD(){
   DelthaEURCAD = MarketInfo("EURCAD",MODE_BID) * MathPow(10, MarketInfo("EURCAD",MODE_DIGITS)) - BidPrevEURCAD * MathPow(10, MarketInfo("EURCAD",MODE_DIGITS));
   PathEURCAD = StringConcatenate( DoubleToStr ( DelthaEURCAD, 0 ), PathEURCAD );
   if (DelthaEURCAD >= 0) {
      PathEURCAD = StringConcatenate("+", PathEURCAD);
      }
   PathEURCAD = StringSubstr ( PathEURCAD, 0, PathLimit );      
   if (MarketInfo("EURCAD",MODE_BID)!= BidPrevEURCAD){
   Counter ++;   
   SaveTick ( CompanyName(), "EURCAD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("EURCAD",MODE_BID), MarketInfo("EURCAD",MODE_ASK), MarketInfo("EURCAD",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevEURCAD = MarketInfo("EURCAD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}


int SaveStatEURAUD(){
   DelthaEURAUD = MarketInfo("EURAUD",MODE_BID) * MathPow(10, MarketInfo("EURAUD",MODE_DIGITS)) - BidPrevEURAUD * MathPow(10, MarketInfo("EURAUD",MODE_DIGITS));
   PathEURAUD = StringConcatenate( DoubleToStr ( DelthaEURAUD, 0 ), PathEURAUD );
   if (DelthaEURAUD >= 0) {
      PathEURAUD = StringConcatenate("+", PathEURAUD);
      }
   PathEURAUD = StringSubstr ( PathEURAUD, 0, PathLimit );      
   if (MarketInfo("EURAUD",MODE_BID)!= BidPrevEURAUD){
   Counter ++;   
   SaveTick ( CompanyName(), "EURAUD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("EURAUD",MODE_BID), MarketInfo("EURAUD",MODE_ASK), MarketInfo("EURAUD",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevEURAUD = MarketInfo("EURAUD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}
/*
int SaveStatNZDUSD(){
   DelthaNZDUSD = MarketInfo("NZDUSD",MODE_BID) * MathPow(10, MarketInfo("NZDUSD",MODE_DIGITS)) - BidPrevNZDUSD * MathPow(10, MarketInfo("NZDUSD",MODE_DIGITS));
   PathNZDUSD = StringConcatenate( DoubleToStr ( DelthaNZDUSD, 0 ), PathNZDUSD );
   if (DelthaNZDUSD >= 0) {
      PathNZDUSD = StringConcatenate("+", PathNZDUSD);
      }
   PathNZDUSD = StringSubstr ( PathNZDUSD, 0, PathLimit );      
   if (MarketInfo("NZDUSD",MODE_BID)!= BidPrevNZDUSD){
   Counter ++;   
   SaveTick ( CompanyName(), "NZDUSD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("NZDUSD",MODE_BID), MarketInfo("NZDUSD",MODE_ASK), MarketInfo("NZDUSD",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevNZDUSD = MarketInfo("NZDUSD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatUSDSEK(){
   DelthaUSDSEK = MarketInfo("USDSEK",MODE_BID) * MathPow(10, MarketInfo("USDSEK",MODE_DIGITS)) - BidPrevUSDSEK * MathPow(10, MarketInfo("USDSEK",MODE_DIGITS));
   PathUSDSEK = StringConcatenate( DoubleToStr ( DelthaUSDSEK, 0 ), PathUSDSEK );
   if (DelthaUSDSEK >= 0) {
      PathUSDSEK = StringConcatenate("+", PathUSDSEK);
      }
   PathUSDSEK = StringSubstr ( PathUSDSEK, 0, PathLimit );      
   if (MarketInfo("USDSEK",MODE_BID)!= BidPrevUSDSEK){
   Counter ++;   
   SaveTick ( CompanyName(), "USDSEK", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDSEK",MODE_BID), MarketInfo("USDSEK",MODE_ASK), MarketInfo("USDSEK",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevUSDSEK = MarketInfo("USDSEK",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatUSDDKK(){
   DelthaUSDDKK = MarketInfo("USDDKK",MODE_BID) * MathPow(10, MarketInfo("USDDKK",MODE_DIGITS)) - BidPrevUSDDKK * MathPow(10, MarketInfo("USDDKK",MODE_DIGITS));
   PathUSDDKK = StringConcatenate( DoubleToStr ( DelthaUSDDKK, 0 ), PathUSDDKK );
   if (DelthaUSDDKK >= 0) {
      PathUSDDKK = StringConcatenate("+", PathUSDDKK);
      }
   PathUSDDKK = StringSubstr ( PathUSDDKK, 0, PathLimit );      
   if (MarketInfo("USDDKK",MODE_BID)!= BidPrevUSDDKK){
   Counter ++;   
   SaveTick ( CompanyName(), "USDDKK", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDDKK",MODE_BID), MarketInfo("USDDKK",MODE_ASK), MarketInfo("USDDKK",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevUSDDKK = MarketInfo("USDDKK",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatUSDNOK(){
   DelthaUSDNOK = MarketInfo("USDNOK",MODE_BID) * MathPow(10, MarketInfo("USDNOK",MODE_DIGITS)) - BidPrevUSDNOK * MathPow(10, MarketInfo("USDNOK",MODE_DIGITS));
   PathUSDNOK = StringConcatenate( DoubleToStr ( DelthaUSDNOK, 0 ), PathUSDNOK );
   if (DelthaUSDNOK >= 0) {
      PathUSDNOK = StringConcatenate("+", PathUSDNOK);
      }
   PathUSDNOK = StringSubstr ( PathUSDNOK, 0, PathLimit );      
   if (MarketInfo("USDNOK",MODE_BID)!= BidPrevUSDNOK){
   Counter ++;   
   SaveTick ( CompanyName(), "USDNOK", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDNOK",MODE_BID), MarketInfo("USDNOK",MODE_ASK), MarketInfo("USDNOK",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevUSDNOK = MarketInfo("USDNOK",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatUSDSGD(){
   DelthaUSDSGD = MarketInfo("USDSGD",MODE_BID) * MathPow(10, MarketInfo("USDSGD",MODE_DIGITS)) - BidPrevUSDSGD * MathPow(10, MarketInfo("USDSGD",MODE_DIGITS));
   PathUSDSGD = StringConcatenate( DoubleToStr ( DelthaUSDSGD, 0 ), PathUSDSGD );
   if (DelthaUSDSGD >= 0) {
      PathUSDSGD = StringConcatenate("+", PathUSDSGD);
      }
   PathUSDSGD = StringSubstr ( PathUSDSGD, 0, PathLimit );      
   if (MarketInfo("USDSGD",MODE_BID)!= BidPrevUSDSGD){
   Counter ++;   
   SaveTick ( CompanyName(), "USDSGD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDSGD",MODE_BID), MarketInfo("USDSGD",MODE_ASK), MarketInfo("USDSGD",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevUSDSGD = MarketInfo("USDSGD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

int SaveStatUSDZAR(){
   DelthaUSDZAR = MarketInfo("USDZAR",MODE_BID) * MathPow(10, MarketInfo("USDZAR",MODE_DIGITS)) - BidPrevUSDZAR * MathPow(10, MarketInfo("USDZAR",MODE_DIGITS));
   PathUSDZAR = StringConcatenate( DoubleToStr ( DelthaUSDZAR, 0 ), PathUSDZAR );
   if (DelthaUSDZAR >= 0) {
      PathUSDZAR = StringConcatenate("+", PathUSDZAR);
      }
   PathUSDZAR = StringSubstr ( PathUSDZAR, 0, PathLimit );      
   if (MarketInfo("USDZAR",MODE_BID)!= BidPrevUSDZAR){
   Counter ++;   
   SaveTick ( CompanyName(), "USDZAR", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("USDZAR",MODE_BID), MarketInfo("USDZAR",MODE_ASK), MarketInfo("USDZAR",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevUSDZAR = MarketInfo("USDZAR",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}
*/
int SaveStatCHFJPY(){
   DelthaCHFJPY = MarketInfo("CHFJPY",MODE_BID) * MathPow(10, MarketInfo("CHFJPY",MODE_DIGITS)) - BidPrevCHFJPY * MathPow(10, MarketInfo("CHFJPY",MODE_DIGITS));
   PathCHFJPY = StringConcatenate( DoubleToStr ( DelthaCHFJPY, 0 ), PathCHFJPY );
   if (DelthaCHFJPY >= 0) {
      PathCHFJPY = StringConcatenate("+", PathCHFJPY);
      }
   PathCHFJPY = StringSubstr ( PathCHFJPY, 0, PathLimit );      
   if (MarketInfo("CHFJPY",MODE_BID)!= BidPrevCHFJPY){
   Counter ++;   
   SaveTick ( CompanyName(), "CHFJPY", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("CHFJPY",MODE_BID), MarketInfo("CHFJPY",MODE_ASK), MarketInfo("CHFJPY",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevCHFJPY = MarketInfo("CHFJPY",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}

/*
int SaveStatGOLD(){
   DelthaGOLD = MarketInfo("GOLD",MODE_BID) * MathPow(10, MarketInfo("GOLD",MODE_DIGITS)) - BidPrevGOLD * MathPow(10, MarketInfo("GOLD",MODE_DIGITS));
   PathGOLD = StringConcatenate( DoubleToStr ( DelthaGOLD, 0 ), PathGOLD );
   if (DelthaGOLD >= 0) {
      PathGOLD = StringConcatenate("+", PathGOLD);
      }
   PathGOLD = StringSubstr ( PathGOLD, 0, PathLimit );      
   if (MarketInfo("GOLD",MODE_BID)!= BidPrevGOLD){
   Counter ++;   
   SaveTick ( CompanyName(), "GOLD", TimeToStr(CurTime(), TIME_DATE | TIME_MINUTES|TIME_SECONDS), Counter, MarketInfo("GOLD",MODE_BID), MarketInfo("GOLD",MODE_ASK), MarketInfo("GOLD",MODE_POINT));     //  (Australian Dollar vs Hungary Forint)
   BidPrevGOLD = MarketInfo("GOLD",MODE_BID); //  (Australian Dollar vs Swiss Franc)
      }
   return (0);
}
*/
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()  {
   while(IsStopped()==false){
   SaveStatEURUSD();
   SaveStatUSDCHF();
   SaveStatGBPUSD();
   SaveStatUSDJPY();
   
   SaveStatAUDUSD();
   SaveStatUSDCAD();
   SaveStatEURCHF();
   SaveStatEURJPY();

   SaveStatEURGBP();
   SaveStatGBPJPY();
   SaveStatGBPCHF();
   SaveStatEURCAD();
     
   SaveStatEURAUD();
   //SaveStatNZDUSD();
   //SaveStatUSDSEK();
   //SaveStatUSDDKK();
   
   //SaveStatUSDNOK();
  // SaveStatUSDSGD();
   //SaveStatUSDZAR();
   SaveStatCHFJPY();
   
 //  SaveStatGOLD();
     }
   return(0);
  }
//+------------------------------------------------------------------+